=== source/layers/validation/checkers/CMakeLists.txt ===
add_subdirectory(basic_leak)
add_subdirectory(events_checker)
add_subdirectory(parameter_validation)
add_subdirectory(template)
